var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  alterState: () => import_language_common2.alterState,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  default: () => src_default,
  each: () => import_language_common2.each,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  findDocuments: () => findDocuments,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  insertDocuments: () => insertDocuments,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  sourceValue: () => import_language_common2.sourceValue,
  updateDocument: () => updateDocument
});
module.exports = __toCommonJS(src_exports);

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  alterState: () => import_language_common2.alterState,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  each: () => import_language_common2.each,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  findDocuments: () => findDocuments,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  insertDocuments: () => insertDocuments,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  sourceValue: () => import_language_common2.sourceValue,
  updateDocument: () => updateDocument
});
var import_language_common = require("@openfn/language-common");
var import_mongodb = __toESM(require("mongodb"), 1);
var import_language_common2 = require("@openfn/language-common");
var { MongoClient } = import_mongodb.default;
function execute(...operations) {
  const initialState = {
    references: [],
    data: null
  };
  return (state) => {
    return (0, import_language_common.execute)(
      connect,
      ...operations,
      disconnect
    )({ ...initialState, ...state });
  };
}
function connect(state) {
  const { clusterHostname, username, password } = state.configuration;
  const uri = `mongodb+srv://${encodeURIComponent(
    username
  )}:${encodeURIComponent(
    password
  )}@${clusterHostname}/test?retryWrites=true&w=majority`;
  const client = new MongoClient(uri, { useNewUrlParser: true });
  return new Promise((resolve, reject) => {
    client.connect((err) => {
      if (err) {
        reject(err);
      } else {
        console.log("Connected successfully to server");
        resolve({ ...state, client });
      }
    });
  });
}
function disconnect(state) {
  state.client.close();
  delete state.client;
  return state;
}
function insertDocuments(params) {
  return (state) => {
    const { client } = state;
    try {
      const { database, collection, documents, callback } = (0, import_language_common.expandReferences)(params)(state);
      const db = client.db(database);
      const mCollection = db.collection(collection);
      return new Promise((resolve, reject) => {
        mCollection.insertMany(documents, (err, result) => {
          if (err) {
            reject(err);
            state.client.close();
          } else {
            console.log(
              `Inserted ${documents.length} documents into the collection`
            );
            console.log(JSON.stringify(result, null, 2));
            const nextState = (0, import_language_common.composeNextState)(state, result);
            if (callback)
              resolve(callback(nextState));
            resolve(nextState);
          }
        });
      });
    } catch (error) {
      state.client.close();
      throw error;
    }
  };
}
function findDocuments(params) {
  return (state) => {
    const { client } = state;
    try {
      const { database, collection, query, callback } = (0, import_language_common.expandReferences)(params)(state);
      const db = client.db(database);
      const mCollection = db.collection(collection);
      return new Promise((resolve, reject) => {
        mCollection.find(query).toArray((err, docs) => {
          if (err) {
            reject(err);
            state.client.close();
          } else {
            console.log(`Found ${docs.length} documents in the collection`);
            console.log(JSON.stringify(docs, null, 2));
            const nextState = (0, import_language_common.composeNextState)(state, docs);
            if (callback)
              resolve(callback(nextState));
            resolve(nextState);
          }
        });
      });
    } catch (error) {
      state.client.close();
      throw error;
    }
  };
}
function updateDocument(params) {
  return (state) => {
    const { client } = state;
    try {
      const { database, collection, filter, changes, options, callback } = (0, import_language_common.expandReferences)(params)(state);
      const db = client.db(database);
      const mCollection = db.collection(collection);
      return new Promise((resolve, reject) => {
        mCollection.updateMany(
          filter,
          { $set: changes },
          options,
          (err, result) => {
            if (err) {
              reject(err);
              state.client.close();
            } else {
              console.log(
                `Updated a document matching ${JSON.stringify(
                  filter
                )} in the collection.`
              );
              console.log(JSON.stringify(result, null, 2));
              const nextState = (0, import_language_common.composeNextState)(state, result);
              if (callback)
                resolve(callback(nextState));
              resolve(nextState);
            }
          }
        );
      });
    } catch (error) {
      state.client.close();
      throw error;
    }
  };
}

// src/index.js
var src_default = Adaptor_exports;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  alterState,
  dataPath,
  dataValue,
  each,
  execute,
  field,
  fields,
  findDocuments,
  fn,
  fnIf,
  insertDocuments,
  lastReferenceValue,
  merge,
  sourceValue,
  updateDocument
});
